/*
    This file is part of task -- a task scheduler for distributed computations
    Copyright (C) 2012  Laurent Poirrier

    task is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef TASK_CONFIG_H
#define TASK_CONFIG_H
#include <unistd.h>

#define TASK_VERSION	1
#define TASK_REVISION	4

#define TASK_DEFAULT_SHELL		"/bin/sh"
#define TASK_DEFAULT_HOST		"host"
#define TASK_DEFAULT_FILE_SIZE_MAX	(16 << 20)
#define TASK_DEFAULT_PROTO_BUFF_MAX	(18 << 20)
#define TASK_DEFAULT_BLOCK_SIZE		65536
#define TASK_DEFAULT_SERVICE		"8000"

typedef struct task_config_t {
	char **envp;
	char *shell;
	char *host;
	size_t file_size_max;
	size_t proto_buff_max;
	size_t block_size;
	char *default_service;
	int cpus_online;
} task_config;

extern task_config conf;

void config_init(char **envp);
void config_clear();

#endif


