/*
    This file is part of task -- a task scheduler for distributed computations
    Copyright (C) 2012  Laurent Poirrier

    task is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef TASK_CONTROL_H
#define TASK_CONTROL_H

int task_add(const char *node, const char *service,
	const char *dir, const char *cmd, int n, char **names);

// see common.h for flags values
int task_rm(const char *node, const char *service,
	int flags, const char *dir, int n, char **names);

int task_exec(const char *node, const char *service,
	const char *cmd);

// see common.h for flags values
int task_list(const char *node, const char *service, int flags);

int task_nodes(const char *node, const char *service);


#endif

