/*
    This file is part of task -- a task scheduler for distributed computations
    Copyright (C) 2012  Laurent Poirrier

    task is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef TASK_NETWORK_H
#define TASK_NETWORK_H
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>

#define NETSERV_ALL		1
#define NETSERV_LOOPBACK	2

typedef struct netpeer_t {
	int fd;
	char serv[32];
	char host[1025];
} netpeer;

int  netserv_init(const char *node, const char *service, int flags);
int netserv_accept(int fd, netpeer *peer);

int  netcli_init(const char *node, const char *service);

#endif

